stages:
    - construction
    - verification
    - deploiement
    - deploiement prod
    - docker
    - test docker

variables:
    DOMAINE_TEST: formation-gitlabNLE.surge.sh
    DOMAINE_PROD: formation-gitlabNLE.surge.sh
    IMAGE_TAG: $CI_REGISTRY_IMAGE$CI_PIPELILNE_IID
    IMAGE_TAG_LATEST: $CI_REGISTRY_IMAGE:latest
build:
    stage: construction
    script:
        - echo "build job"
        - npm ci
        - npm run build
    image: node:14
    artifacts:
        paths:
            - public/
        
.test:
    stage: verification
    script:
        - echo "build test"
        - grep "build something great" ./public/index.html
    image: alpine:latest

.new test:
    stage: verification
    image: node:14
    script:
        - npm ci
        - npm run serve &
        - sleep 10
        - curl http://localhost:9000 | tac | tac | grep -q "build something great"

.job surge:
    stage: deploiement
    image: node:14
    script:
        - npx surge --project ./public --domain formation-gitlabNLE.surge.sh

.deploiement prod:
    stage: deploiement prod
    when: manual
    only: [master]
    script:
        - npx surge --project ./public --domain $DOMAINE_PROD
    environment:
        name: production
        url: http://$DOMAINE_PROD

image docker:
    stage: docker
    image: docker:20.10.7
    services:
        - docker:20.10.7-dind
    script:
        - docker build -t $IMAGE_TAG -t $IMAGE_TAG_LATEST .
        - docker push $IMAGE_TAG
        - docker push $IMAGE_TAG_LATEST

test docker:
    stage: test docker
    image: docker:20.10.7
    services:
        - docker:20.10.7-dind
    before_script:
        - apk add --update curl
    script:
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker pull $IMAGE_TAG
        - docker run -d -p 8080:80 --name website $IMAGE_TAG
        - sleep 10
        - curl http://docker:8080 | tac | tac | grep -q "build something great"